#ifndef __MATCHSTR_H
#define __MATCHSTR_H


#include <string>

class MatchStr
{
  friend std::istream& operator>>(std::istream& is, const MatchStr& s);
  const std::string str;

public:
  MatchStr(const std::string& s): str(s) {}

};

inline std::istream& operator>>(std::istream& is, const MatchStr& s)
{
  std::string tmp_str;
  is >> tmp_str;
  if(s.str != tmp_str)
    is.clear(std::ios::failbit);
  return is;
}

#endif
