#ifndef __VEC3I_H
#define __VEC3I_H

#include <math.h>
#include "ArithVec.h"

class Vec3f;
class Vec3uc;
class Vec3usi;

class Vec3i: public ArithVec<int,Vec3i,3>
{
public:
  
  Vec3i() {}
  Vec3i(int _a,int _b,int _c): ArithVec<int,Vec3i,3>(_a,_b,_c) {}

  explicit Vec3i(const Vec3f& v);
  explicit Vec3i(const Vec3uc& v);
  explicit Vec3i(const Vec3usi& v);

};

#endif
