#ifndef __VEC3UC_H
#define __VEC3UC_H

#include "ArithVec3.h"
#include "Vec3i.h"

typedef unsigned char UChar;

class Vec3uc: public ArithVec3<UChar,Vec3uc>
{

public:

  Vec3uc() {}
  Vec3uc(UChar _a, UChar _b, UChar _c): ArithVec3<UChar,Vec3uc>(_a,_b,_c) {}

  explicit Vec3uc(const Vec3i& v): 
    ArithVec3<UChar,Vec3uc>(v[0]&0xff, v[1]&0xff, v[2]&0xff) {}
};

#endif
