#ifndef __VEC3USI_H
#define __VEC3USI_H

#include "ArithVec3.h"
#include "Vec3i.h"

typedef unsigned short int USInt;

class Vec3usi: public ArithVec3<USInt,Vec3usi>
{

public:

  Vec3usi() {}
  Vec3usi(USInt _a, USInt _b, USInt _c): ArithVec3<USInt,Vec3usi>(_a,_b,_c) {}

  explicit Vec3usi(const Vec3i& v): 
    ArithVec3<USInt,Vec3usi>(v[0]&0xffff, v[1]&0xffff, v[2]&0xffff) {}
};

#endif
