#ifndef _SFRotation_
#define _SFRotation_

#include <math.h>
#include <stdio.h>

class SFRotation {
// Variables
private:
	float	quat[4];

// Constructor/destructor
public:
	SFRotation();
	SFRotation(float x, float y, float z, float rot);
	SFRotation(float value[4]);

// Methods
public:
	void	setValue(float x, float y, float z, float rot);
	void	setValue(float value[4]);
	void	getValue(float value[4]) const;
	void	getMatrix(float *matrix) const;
	void	mult(SFRotation q1, SFRotation q2);

	// Accesses indexed component of vector
	float&  operator [](int i) { return quat[i]; }
	const float&  operator [](int i) const { return quat[i]; }
};

#endif
