#ifndef __HESSENORMALFORM_H
#define __HESSENORMALFORM_H

#include "GeometricalPrimitive.h"

class HesseNormalForm: public GeometricalPrimitive
{
public:

	/** Get foot point of HNF from another point in space.

			THe first argument is the point whence we want the closest 
			point on the surface of the HNF, i.e. the foot point.

			A unit length gradient is stored by the function in the
			second argument, and the function returns the distance. */
	virtual float foot_point(const Vec3f&, Vec3f&) const = 0;
};


#endif
