#ifndef PERSPECTIVETRANSFORMATION_H
#define PERSPECTIVETRANSFORMATION_H

#include "MatrixTransformation.h"

/******************************************************************************
 *                                                                           *
 * class PerspectiveTransformation: public MatrixTransformation              *
 *                                                                           *
 *                                                                           *
 *****************************************************************************/

class PerspectiveTransformation: public MatrixTransformation
{
  ///
  float dist;
  
public:

  ///
  PerspectiveTransformation()
    {
      init_mtm(perspective_matrix(1));
    }

  ///
  PerspectiveTransformation(float d)
    {
      init_mtm(perspective_matrix(d));
      init_hist(TransformationDesc(PERSPECTIVE,0,0,d));
    }
};


#endif 
